#ifndef __BASE_H
#define __BASE_H

#include <stdio.h>
#include <stdint.h>
#include <memory>

/**
 * @class Pd_Index
 */

template <typename _Key, typename _Value>
class Pd_Index
{
    public:

        /**
         * @class ConstIterator
         */

        class ConstIterator
        {
            public:
                /**
                 * @brief   Destructor.
                 */
                virtual ~ConstIterator() {}

                /**
                 * @brief   Position the iterator at the begin of the index.
                 */
                virtual void Begin() = 0;

        };

        /**
         * Iterator 
         */

        class Iterator : public virtual ConstIterator
    {
        public:
            /**
             * @brief   Destructor.
             */
            virtual ~Iterator() {}

    };

};
#endif
